/*
 * Browshot API
 * Take screenshots of any website in real time
 *
 * OpenAPI spec version: 1.16.0
 * Contact: support@browshot.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.Browser;

/**
 * Instance
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2017-01-29T05:18:22.088Z")
public class Instance {
  @SerializedName("id")
  private Integer id = null;

  @SerializedName("width")
  private Integer width = null;

  @SerializedName("height")
  private Integer height = null;

  @SerializedName("load")
  private Float load = null;

  @SerializedName("browser")
  private Browser browser = null;

  /**
   * public, shared or private
   */
  public enum TypeEnum {
    @SerializedName("public")
    PUBLIC("public"),
    
    @SerializedName("shared")
    SHARED("shared"),
    
    @SerializedName("private")
    PRIVATE("private");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("type")
  private TypeEnum type = null;

  @SerializedName("screenshot_cost")
  private Integer screenshotCost = null;

  @SerializedName("country")
  private String country = null;

  public Instance id(Integer id) {
    this.id = id;
    return this;
  }

   /**
   * instance ID (required to requests screenshots)
   * @return id
  **/
  @ApiModelProperty(example = "null", value = "instance ID (required to requests screenshots)")
  public Integer getId() {
    return id;
  }

  public void setId(Integer id) {
    this.id = id;
  }

  public Instance width(Integer width) {
    this.width = width;
    return this;
  }

   /**
   * screen width in pixels
   * @return width
  **/
  @ApiModelProperty(example = "null", value = "screen width in pixels")
  public Integer getWidth() {
    return width;
  }

  public void setWidth(Integer width) {
    this.width = width;
  }

  public Instance height(Integer height) {
    this.height = height;
    return this;
  }

   /**
   * screen height in pixels
   * @return height
  **/
  @ApiModelProperty(example = "null", value = "screen height in pixels")
  public Integer getHeight() {
    return height;
  }

  public void setHeight(Integer height) {
    this.height = height;
  }

  public Instance load(Float load) {
    this.load = load;
    return this;
  }

   /**
   * instance load:  < 1: new screenshot requests will be processed immediately,  1-2: new screenshot requests will be processed in about two minutes,  2-3: new screenshot requests will be processed in about four minutes,  3-4: new screenshot requests will be processed in about six minutes,  etc. 
   * @return load
  **/
  @ApiModelProperty(example = "null", value = "instance load:  < 1: new screenshot requests will be processed immediately,  1-2: new screenshot requests will be processed in about two minutes,  2-3: new screenshot requests will be processed in about four minutes,  3-4: new screenshot requests will be processed in about six minutes,  etc. ")
  public Float getLoad() {
    return load;
  }

  public void setLoad(Float load) {
    this.load = load;
  }

  public Instance browser(Browser browser) {
    this.browser = browser;
    return this;
  }

   /**
   * Get browser
   * @return browser
  **/
  @ApiModelProperty(example = "null", value = "")
  public Browser getBrowser() {
    return browser;
  }

  public void setBrowser(Browser browser) {
    this.browser = browser;
  }

  public Instance type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * public, shared or private
   * @return type
  **/
  @ApiModelProperty(example = "null", value = "public, shared or private")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public Instance screenshotCost(Integer screenshotCost) {
    this.screenshotCost = screenshotCost;
    return this;
  }

   /**
   * number of credits for each screenshot
   * @return screenshotCost
  **/
  @ApiModelProperty(example = "null", value = "number of credits for each screenshot")
  public Integer getScreenshotCost() {
    return screenshotCost;
  }

  public void setScreenshotCost(Integer screenshotCost) {
    this.screenshotCost = screenshotCost;
  }

  public Instance country(String country) {
    this.country = country;
    return this;
  }

   /**
   * instance's country of origin
   * @return country
  **/
  @ApiModelProperty(example = "null", value = "instance's country of origin")
  public String getCountry() {
    return country;
  }

  public void setCountry(String country) {
    this.country = country;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Instance instance = (Instance) o;
    return Objects.equals(this.id, instance.id) &&
        Objects.equals(this.width, instance.width) &&
        Objects.equals(this.height, instance.height) &&
        Objects.equals(this.load, instance.load) &&
        Objects.equals(this.browser, instance.browser) &&
        Objects.equals(this.type, instance.type) &&
        Objects.equals(this.screenshotCost, instance.screenshotCost) &&
        Objects.equals(this.country, instance.country);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, width, height, load, browser, type, screenshotCost, country);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Instance {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    width: ").append(toIndentedString(width)).append("\n");
    sb.append("    height: ").append(toIndentedString(height)).append("\n");
    sb.append("    load: ").append(toIndentedString(load)).append("\n");
    sb.append("    browser: ").append(toIndentedString(browser)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    screenshotCost: ").append(toIndentedString(screenshotCost)).append("\n");
    sb.append("    country: ").append(toIndentedString(country)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

