/*
 * Browshot API
 * Take screenshots of any website in real time
 *
 * OpenAPI spec version: 1.16.0
 * Contact: support@browshot.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * Screenshot
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2017-01-29T05:18:22.088Z")
public class Screenshot {
  @SerializedName("id")
  private Integer id = null;

  /**
   * status of the request: \"in_queue\", \"processing\", \"finished\", \"error\" 
   */
  public enum StatusEnum {
    @SerializedName("in_queue")
    IN_QUEUE("in_queue"),
    
    @SerializedName("processing")
    PROCESSING("processing"),
    
    @SerializedName("finished")
    FINISHED("finished"),
    
    @SerializedName("error")
    ERROR("error");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("status")
  private StatusEnum status = null;

  @SerializedName("error")
  private String error = null;

  @SerializedName("priority")
  private Integer priority = null;

  @SerializedName("url")
  private String url = null;

  /**
   * screenshot size requested
   */
  public enum SizeEnum {
    @SerializedName("screen")
    SCREEN("screen"),
    
    @SerializedName("page")
    PAGE("page");

    private String value;

    SizeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
  }

  @SerializedName("size")
  private SizeEnum size = null;

  @SerializedName("width")
  private Integer width = null;

  @SerializedName("height")
  private Integer height = null;

  @SerializedName("final_url")
  private String finalUrl = null;

  @SerializedName("scale")
  private Double scale = null;

  @SerializedName("instance_id")
  private Integer instanceId = null;

  @SerializedName("cost")
  private Integer cost = null;

  @SerializedName("referer")
  private String referer = null;

  @SerializedName("post_data")
  private String postData = null;

  @SerializedName("cookie")
  private String cookie = null;

  @SerializedName("delay")
  private Integer delay = null;

  @SerializedName("flash_delay")
  private Integer flashDelay = null;

  @SerializedName("details")
  private Integer details = null;

  @SerializedName("script")
  private String script = null;

  @SerializedName("shared_url")
  private String sharedUrl = null;

  public Screenshot id(Integer id) {
    this.id = id;
    return this;
  }

   /**
   * screenshot ID
   * @return id
  **/
  @ApiModelProperty(example = "null", required = true, value = "screenshot ID")
  public Integer getId() {
    return id;
  }

  public void setId(Integer id) {
    this.id = id;
  }

  public Screenshot status(StatusEnum status) {
    this.status = status;
    return this;
  }

   /**
   * status of the request: \"in_queue\", \"processing\", \"finished\", \"error\" 
   * @return status
  **/
  @ApiModelProperty(example = "null", required = true, value = "status of the request: \"in_queue\", \"processing\", \"finished\", \"error\" ")
  public StatusEnum getStatus() {
    return status;
  }

  public void setStatus(StatusEnum status) {
    this.status = status;
  }

  public Screenshot error(String error) {
    this.error = error;
    return this;
  }

   /**
   * description of the problem that occurred
   * @return error
  **/
  @ApiModelProperty(example = "null", value = "description of the problem that occurred")
  public String getError() {
    return error;
  }

  public void setError(String error) {
    this.error = error;
  }

  public Screenshot priority(Integer priority) {
    this.priority = priority;
    return this;
  }

   /**
   * priority given to the screenshot: high (1) to low (3)
   * minimum: 1
   * maximum: 3
   * @return priority
  **/
  @ApiModelProperty(example = "null", value = "priority given to the screenshot: high (1) to low (3)")
  public Integer getPriority() {
    return priority;
  }

  public void setPriority(Integer priority) {
    this.priority = priority;
  }

  public Screenshot url(String url) {
    this.url = url;
    return this;
  }

   /**
   * original URL requested
   * @return url
  **/
  @ApiModelProperty(example = "null", required = true, value = "original URL requested")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }

  public Screenshot size(SizeEnum size) {
    this.size = size;
    return this;
  }

   /**
   * screenshot size requested
   * @return size
  **/
  @ApiModelProperty(example = "null", value = "screenshot size requested")
  public SizeEnum getSize() {
    return size;
  }

  public void setSize(SizeEnum size) {
    this.size = size;
  }

  public Screenshot width(Integer width) {
    this.width = width;
    return this;
  }

   /**
   * screenshot width
   * @return width
  **/
  @ApiModelProperty(example = "null", value = "screenshot width")
  public Integer getWidth() {
    return width;
  }

  public void setWidth(Integer width) {
    this.width = width;
  }

  public Screenshot height(Integer height) {
    this.height = height;
    return this;
  }

   /**
   * screenshot height
   * @return height
  **/
  @ApiModelProperty(example = "null", value = "screenshot height")
  public Integer getHeight() {
    return height;
  }

  public void setHeight(Integer height) {
    this.height = height;
  }

  public Screenshot finalUrl(String finalUrl) {
    this.finalUrl = finalUrl;
    return this;
  }

   /**
   * URL of the screenshot (redirections can occur)
   * @return finalUrl
  **/
  @ApiModelProperty(example = "null", value = "URL of the screenshot (redirections can occur)")
  public String getFinalUrl() {
    return finalUrl;
  }

  public void setFinalUrl(String finalUrl) {
    this.finalUrl = finalUrl;
  }

  public Screenshot scale(Double scale) {
    this.scale = scale;
    return this;
  }

   /**
   * image scale. Always 1 for desktop browsers; mobiles may change the scale (zoom in or zoom out) to fit the page on the screen
   * @return scale
  **/
  @ApiModelProperty(example = "null", value = "image scale. Always 1 for desktop browsers; mobiles may change the scale (zoom in or zoom out) to fit the page on the screen")
  public Double getScale() {
    return scale;
  }

  public void setScale(Double scale) {
    this.scale = scale;
  }

  public Screenshot instanceId(Integer instanceId) {
    this.instanceId = instanceId;
    return this;
  }

   /**
   * instance ID used for the screenshot
   * @return instanceId
  **/
  @ApiModelProperty(example = "null", required = true, value = "instance ID used for the screenshot")
  public Integer getInstanceId() {
    return instanceId;
  }

  public void setInstanceId(Integer instanceId) {
    this.instanceId = instanceId;
  }

  public Screenshot cost(Integer cost) {
    this.cost = cost;
    return this;
  }

   /**
   * number of credits spent for the screenshot
   * @return cost
  **/
  @ApiModelProperty(example = "null", value = "number of credits spent for the screenshot")
  public Integer getCost() {
    return cost;
  }

  public void setCost(Integer cost) {
    this.cost = cost;
  }

  public Screenshot referer(String referer) {
    this.referer = referer;
    return this;
  }

   /**
   * custom referrer used (see Custom POST Data, Referer and Cookie)
   * @return referer
  **/
  @ApiModelProperty(example = "null", value = "custom referrer used (see Custom POST Data, Referer and Cookie)")
  public String getReferer() {
    return referer;
  }

  public void setReferer(String referer) {
    this.referer = referer;
  }

  public Screenshot postData(String postData) {
    this.postData = postData;
    return this;
  }

   /**
   * POST data sent (see Custom POST Data, Referer and Cookie)
   * @return postData
  **/
  @ApiModelProperty(example = "null", value = "POST data sent (see Custom POST Data, Referer and Cookie)")
  public String getPostData() {
    return postData;
  }

  public void setPostData(String postData) {
    this.postData = postData;
  }

  public Screenshot cookie(String cookie) {
    this.cookie = cookie;
    return this;
  }

   /**
   * custom cookie used (see Custom POST Data, Referer and Cookie)
   * @return cookie
  **/
  @ApiModelProperty(example = "null", value = "custom cookie used (see Custom POST Data, Referer and Cookie)")
  public String getCookie() {
    return cookie;
  }

  public void setCookie(String cookie) {
    this.cookie = cookie;
  }

  public Screenshot delay(Integer delay) {
    this.delay = delay;
    return this;
  }

   /**
   * number of seconds to wait after page load
   * @return delay
  **/
  @ApiModelProperty(example = "null", value = "number of seconds to wait after page load")
  public Integer getDelay() {
    return delay;
  }

  public void setDelay(Integer delay) {
    this.delay = delay;
  }

  public Screenshot flashDelay(Integer flashDelay) {
    this.flashDelay = flashDelay;
    return this;
  }

   /**
   * number of seconds to wait after page load if Flash elements are present
   * @return flashDelay
  **/
  @ApiModelProperty(example = "null", value = "number of seconds to wait after page load if Flash elements are present")
  public Integer getFlashDelay() {
    return flashDelay;
  }

  public void setFlashDelay(Integer flashDelay) {
    this.flashDelay = flashDelay;
  }

  public Screenshot details(Integer details) {
    this.details = details;
    return this;
  }

   /**
   * level of details about the screenshot and the page
   * minimum: 0
   * maximum: 3
   * @return details
  **/
  @ApiModelProperty(example = "null", value = "level of details about the screenshot and the page")
  public Integer getDetails() {
    return details;
  }

  public void setDetails(Integer details) {
    this.details = details;
  }

  public Screenshot script(String script) {
    this.script = script;
    return this;
  }

   /**
   * URL of optional javascript file executed after the page load event
   * @return script
  **/
  @ApiModelProperty(example = "null", value = "URL of optional javascript file executed after the page load event")
  public String getScript() {
    return script;
  }

  public void setScript(String script) {
    this.script = script;
  }

  public Screenshot sharedUrl(String sharedUrl) {
    this.sharedUrl = sharedUrl;
    return this;
  }

   /**
   * if the screenshot was shared, show the public URL
   * @return sharedUrl
  **/
  @ApiModelProperty(example = "null", value = "if the screenshot was shared, show the public URL")
  public String getSharedUrl() {
    return sharedUrl;
  }

  public void setSharedUrl(String sharedUrl) {
    this.sharedUrl = sharedUrl;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Screenshot screenshot = (Screenshot) o;
    return Objects.equals(this.id, screenshot.id) &&
        Objects.equals(this.status, screenshot.status) &&
        Objects.equals(this.error, screenshot.error) &&
        Objects.equals(this.priority, screenshot.priority) &&
        Objects.equals(this.url, screenshot.url) &&
        Objects.equals(this.size, screenshot.size) &&
        Objects.equals(this.width, screenshot.width) &&
        Objects.equals(this.height, screenshot.height) &&
        Objects.equals(this.finalUrl, screenshot.finalUrl) &&
        Objects.equals(this.scale, screenshot.scale) &&
        Objects.equals(this.instanceId, screenshot.instanceId) &&
        Objects.equals(this.cost, screenshot.cost) &&
        Objects.equals(this.referer, screenshot.referer) &&
        Objects.equals(this.postData, screenshot.postData) &&
        Objects.equals(this.cookie, screenshot.cookie) &&
        Objects.equals(this.delay, screenshot.delay) &&
        Objects.equals(this.flashDelay, screenshot.flashDelay) &&
        Objects.equals(this.details, screenshot.details) &&
        Objects.equals(this.script, screenshot.script) &&
        Objects.equals(this.sharedUrl, screenshot.sharedUrl);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, status, error, priority, url, size, width, height, finalUrl, scale, instanceId, cost, referer, postData, cookie, delay, flashDelay, details, script, sharedUrl);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Screenshot {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("    priority: ").append(toIndentedString(priority)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    size: ").append(toIndentedString(size)).append("\n");
    sb.append("    width: ").append(toIndentedString(width)).append("\n");
    sb.append("    height: ").append(toIndentedString(height)).append("\n");
    sb.append("    finalUrl: ").append(toIndentedString(finalUrl)).append("\n");
    sb.append("    scale: ").append(toIndentedString(scale)).append("\n");
    sb.append("    instanceId: ").append(toIndentedString(instanceId)).append("\n");
    sb.append("    cost: ").append(toIndentedString(cost)).append("\n");
    sb.append("    referer: ").append(toIndentedString(referer)).append("\n");
    sb.append("    postData: ").append(toIndentedString(postData)).append("\n");
    sb.append("    cookie: ").append(toIndentedString(cookie)).append("\n");
    sb.append("    delay: ").append(toIndentedString(delay)).append("\n");
    sb.append("    flashDelay: ").append(toIndentedString(flashDelay)).append("\n");
    sb.append("    details: ").append(toIndentedString(details)).append("\n");
    sb.append("    script: ").append(toIndentedString(script)).append("\n");
    sb.append("    sharedUrl: ").append(toIndentedString(sharedUrl)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

